Package org.optaplanner.core.impl.heuristic.selector.move.composite

## Class UnionMoveSelector<Solution_>

- java.lang.Object
- - org.optaplanner.core.impl.heuristic.selector.AbstractSelector<Solution_>
  - - org.optaplanner.core.impl.heuristic.selector.move.AbstractMoveSelector<Solution_>
    - - org.optaplanner.core.impl.heuristic.selector.move.composite.CompositeMoveSelector<Solution_>
      - - org.optaplanner.core.impl.heuristic.selector.move.composite.UnionMoveSelector<Solution_>

- All Implemented Interfaces:
    `Iterable<Move<Solution_>>`, `EventListener`, `IterableSelector<Solution_,​Move<Solution_>>`, `MoveSelector<Solution_>`, `Selector<Solution_>`, `PhaseLifecycleListener<Solution_>`, `SolverLifecycleListener<Solution_>`

      public class UnionMoveSelector<Solution_>
      extends CompositeMoveSelector<Solution_>

  A `CompositeMoveSelector` that unions 2 or more `MoveSelector`s.

  For example: a union of {A, B, C} and {X, Y} will result in {A, B, C, X, Y}.

  Warning: there is no duplicated `Move` check, so union of {A, B, C} and {B, D} will result in {A, B, C, B, D}.

  See Also:
    `CompositeMoveSelector`

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class | Description
    --- | --- | ---
    `class` | `UnionMoveSelector.RandomUnionMoveIterator` |

  - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected ScoreDirector<Solution_>` | `scoreDirector` |
    `protected SelectionProbabilityWeightFactory<Solution_,​MoveSelector<Solution_>>` | `selectorProbabilityWeightFactory` |

    - ### Fields inherited from class org.optaplanner.core.impl.heuristic.selector.move.composite.CompositeMoveSelector

      `childMoveSelectorList, randomSelection`

    - ### Fields inherited from class org.optaplanner.core.impl.heuristic.selector.AbstractSelector

      `logger, phaseLifecycleSupport, workingRandom`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `UnionMoveSelector​(List<MoveSelector<Solution_>> childMoveSelectorList, boolean randomSelection)` |
    `UnionMoveSelector​(List<MoveSelector<Solution_>> childMoveSelectorList, boolean randomSelection, SelectionProbabilityWeightFactory<Solution_,​MoveSelector<Solution_>> selectorProbabilityWeightFactory)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `long` | `getSize()` | A random JIT `Selector` with `Selector.isNeverEnding()` true should return a size as if it would be able to return each distinct element only once, because the size can be used in `SelectionProbabilityWeightFactory`.
    `boolean` | `isNeverEnding()` | Is true if `Selector.isCountable()` is false or if this selector is in random order (for most cases).
    `Iterator<Move<Solution_>>` | `iterator()` |
    `void` | `stepEnded​(AbstractStepScope<Solution_> stepScope)` |
    `void` | `stepStarted​(AbstractStepScope<Solution_> stepScope)` |
    `String` | `toString()` |

    - ### Methods inherited from class org.optaplanner.core.impl.heuristic.selector.move.composite.CompositeMoveSelector

      `getChildMoveSelectorList, isCountable, supportsPhaseAndSolverCaching`

    - ### Methods inherited from class org.optaplanner.core.impl.heuristic.selector.AbstractSelector

      `getCacheType, phaseEnded, phaseStarted, solvingEnded, solvingStarted`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface java.lang.Iterable

      `forEach`

    - ### Methods inherited from interface org.optaplanner.core.impl.heuristic.selector.IterableSelector

      `spliterator`

    - ### Methods inherited from interface org.optaplanner.core.impl.phase.event.PhaseLifecycleListener

      `phaseEnded, phaseStarted`

    - ### Methods inherited from interface org.optaplanner.core.impl.heuristic.selector.Selector

      `getCacheType`

    - ### Methods inherited from interface org.optaplanner.core.impl.solver.event.SolverLifecycleListener

      `solvingEnded, solvingStarted`

- - ### Field Detail

    - #### selectorProbabilityWeightFactory

          protected final SelectionProbabilityWeightFactory<Solution_,​MoveSelector<Solution_>> selectorProbabilityWeightFactory

    - #### scoreDirector

          protected ScoreDirector<Solution_> scoreDirector

  - ### Constructor Detail

    - #### UnionMoveSelector

          public UnionMoveSelector​(List<MoveSelector<Solution_>> childMoveSelectorList,
                                   boolean randomSelection)

    - #### UnionMoveSelector

          public UnionMoveSelector​(List<MoveSelector<Solution_>> childMoveSelectorList,
                                   boolean randomSelection,
                                   SelectionProbabilityWeightFactory<Solution_,​MoveSelector<Solution_>> selectorProbabilityWeightFactory)

  - ### Method Detail

    - #### stepStarted

          public void stepStarted​(AbstractStepScope<Solution_> stepScope)

      Specified by:
        `stepStarted` in interface `PhaseLifecycleListener<Solution_>`
      Overrides:
        `stepStarted` in class `AbstractSelector<Solution_>`

    - #### stepEnded

          public void stepEnded​(AbstractStepScope<Solution_> stepScope)

      Specified by:
        `stepEnded` in interface `PhaseLifecycleListener<Solution_>`
      Overrides:
        `stepEnded` in class `AbstractSelector<Solution_>`

    - #### isNeverEnding

          public boolean isNeverEnding()

      Description copied from interface: `Selector`
      Is true if `Selector.isCountable()` is false or if this selector is in random order (for most cases). Is never true when this selector is in shuffled order (which is less scalable but more exact).
      Returns:
        true if the `Iterator.hasNext()` of the `Iterator` created by `Iterable.iterator()` never returns false (except when it's empty).

    - #### getSize

          public long getSize()

      Description copied from interface: `IterableSelector`
      A random JIT `Selector` with `Selector.isNeverEnding()` true should return a size as if it would be able to return each distinct element only once, because the size can be used in `SelectionProbabilityWeightFactory`.
      Returns:
        the approximate number of elements generated by this `Selector`, always `>= 0`

    - #### iterator

          public Iterator<Move<Solution_>> iterator()

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `CompositeMoveSelector<Solution_>`